xfstests: stop special casing nfs and udf
[xfstests-dev.git] / tests / xfs / 138
1 #! /bin/bash
2 # FSQA Test No. 138
3 #
4 # Test for NULL files problem
5 #
6 #-----------------------------------------------------------------------
7 # Copyright (c) 2006 Silicon Graphics, Inc.  All Rights Reserved.
8 #
9 # This program is free software; you can redistribute it and/or
10 # modify it under the terms of the GNU General Public License as
11 # published by the Free Software Foundation.
12 #
13 # This program is distributed in the hope that it would be useful,
14 # but WITHOUT ANY WARRANTY; without even the implied warranty of
15 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
16 # GNU General Public License for more details.
17 #
18 # You should have received a copy of the GNU General Public License
19 # along with this program; if not, write the Free Software Foundation,
20 # Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
21 #
22 #-----------------------------------------------------------------------
23 #
24
25 seq=`basename $0`
26 seqres=$RESULT_DIR/$seq
27 echo "QA output created by $seq"
28
29 here=`pwd`
30 tmp=/tmp/$$
31 status=1    # failure is the default!
32 trap "exit \$status" 0 1 2 3 15
33
34 # get standard environment, filters and checks
35 . ./common/rc
36 . ./common/filter
37
38 # real QA test starts here
39 _supported_fs xfs
40 _supported_os Linux IRIX
41
42 _require_scratch
43 _scratch_mkfs_xfs >/dev/null 2>&1
44 _scratch_mount
45
46 # create files
47 i=1;
48 while [ $i -lt 1000 ]
49 do
50         file=$SCRATCH_MNT/$i
51         xfs_io -f -c "pwrite -b 64k -S 0xff 0 64k" $file > /dev/null
52         if [ $? -ne 0 ]
53         then
54                 echo error creating/writing file $file
55                 exit
56         fi
57         xfs_io -c "truncate 64k" $file > /dev/null
58         if [ $? -ne 0 ]
59         then
60                 echo error truncating file $file
61                 exit
62         fi
63         let i=$i+1
64 done
65
66 # give the system a chance to write something out
67 sleep 10
68
69 src/godown $SCRATCH_MNT
70
71 umount $SCRATCH_MNT
72 _scratch_mount
73 umount $SCRATCH_MNT
74 if [ ! _check_scratch_fs ]
75 then
76         echo error detected in filesystem
77         exit
78 fi
79 _scratch_mount
80
81 # check file size and contents
82 i=1;
83 while [ $i -lt 1000 ]
84 do
85         file=$SCRATCH_MNT/$i
86         # if file does not exist, the create was not logged, skip it
87         if [ -e $file ]
88         then
89                 # if file size is zero it cannot be corrupt, skip it
90                 if [ -s $file ]
91                 then
92                         # if file has non-zero size but no extents then it's contents will be NULLs, bad.
93                         if xfs_bmap $file | grep 'no extents' > /dev/null
94                         then
95                                 echo corrupt file $file - non-zero size but no extents
96                         elif xfs_bmap $file | grep 'hole' > /dev/null
97                         then
98                                 echo corrupt file $file - contains holes
99                         else
100                                 rm -f $file
101                         fi
102                 else
103                         rm -f $file
104                 fi
105         fi
106         let i=$i+1
107 done
108
109 status=0
110 exit